$regfile = "m32def.dat"
$crystal = 12000000
$baud = 1200
$hwstack = 32
$swstack = 32
$framesize = 180


Dim A As Byte                                               '  


                    '    
'******************************************************************************
Dim Seco As Byte                                            '
Dim Mine As Byte                                            '
Dim Hour As Byte                                            '
Dim Day As Byte                                             ' 
Dim Dat As Byte                                             '
Dim Month As Byte                                           '
Dim Year As Byte                                            '




                     '    
'******************************************************************************
Dim Secostr As String * 2
Dim Minestr As String * 2
Dim Hourstr As String * 2
Dim Datstr As String * 2
Dim Monthstr As String * 2
Dim Yearstr As String * 4


                      '  
'******************************************************************************
Config Int0 = Rising
Config Int1 = Rising
Config Int2 = Rising
On Int0 Up
On Int1 Down
On Int2 Setup
Enable Interrupts
Enable Int0
Enable Int1
Enable Int2




                     '   DS1307
'******************************************************************************
'  ds1307
$lib "ds1307clock.lib"

' scl  sda 
Config Sda = Porta.0                                        'I2C Data
Config Scl = Porta.1                                        'I2C Clock

'       ds1307
Const Ds1307w = &HD0                                        ' 
Const Ds1307r = &HD1                                        ' 





                   '     3310
'******************************************************************************

Config Portc.2 = Output                                     'D/C (pin 4)
D3310dc Alias Portc.2

Config Portc.1 = Output                                     'SCE (pin 5)
D3310ce Alias Portc.1

Config Portc.0 = Output                                     'Reset (pin 8)
D3310re Alias Portc.0

' SPI   

Config Spi = Soft , Dout = Portc.3 , Ss = None , Clock = Portc.4

' Spi

Spiinit

$include "3310init.bas"


' 

Call D3310reset
Call D3310init
Call D3310clear


                '      
'------------------------------------------------------------------------------
Year = 12                                                   '
Month = 3                                                   '
Dat = 7                                                     '
Hour = 14                                                   '
Mine = 30                                                   '
Seco = 0                                                    '



Gosub Otpravka                                              '   


                     '      
'******************************************************************************
Otpravka:

 Dat = Makebcd(dat)
 I2cstart
 I2cwbyte Ds1307w
 I2cwbyte 4
 I2cwbyte Dat
 I2cstop

 Month = Makebcd(month)
 I2cstart
 I2cwbyte Ds1307w
 I2cwbyte 5
 I2cwbyte Month
 I2cstop

 Year = Makebcd(year)
 I2cstart
 I2cwbyte Ds1307w
 I2cwbyte 6
 I2cwbyte Year
 I2cstop

 Hour = Makebcd(hour)
 I2cstart
 I2cwbyte Ds1307w
 I2cwbyte 2
 I2cwbyte Hour
 I2cstop

 Mine = Makebcd(mine)
 I2cstart
 I2cwbyte Ds1307w
 I2cwbyte 1
 I2cwbyte Mine
 I2cstop

 Seco = Makebcd(seco)
 I2cstart
 I2cwbyte Ds1307w
 I2cwbyte 0
 I2cwbyte Seco
 I2cstop

Return




'******************************************************************************
                             '  
'******************************************************************************

Do
Disable Interrupts
Gosub Ds1307                                                '     
Gosub Display3310                                           '    
Enable Interrupts

 If A > 0 Then                                              '          
 Gosub Nastrojka
 End If


Waitms 200                                                  '       

Loop

End


$include "3310end.bas"
$include "3310bmp1.bas"
'$include "3310bmp2.bas"








                    '    DS1307
'******************************************************************************
Ds1307:
I2cstart
I2cwbyte Ds1307w
I2cwbyte &H00
I2cstart
I2cwbyte Ds1307r
I2crbyte Seco , Ack
I2crbyte Mine , Ack
I2crbyte Hour , Ack
I2crbyte Day , Ack
I2crbyte Dat , Ack
I2crbyte Month , Ack
I2crbyte Year , Nack
I2cstop
 Seco = Makedec(seco)
 Mine = Makedec(mine)
 Hour = Makedec(hour)
 Day = Makedec(day)
 Dat = Makedec(dat)
 Month = Makedec(month)
 Year = Makedec(year)
Return                                                      '







                       '   
'******************************************************************************
Display3310:

'     
'     
Yearstr = Str(year)
Monthstr = Str(month)
Datstr = Str(dat)
Hourstr = Str(hour)
Minestr = Str(mine)
Secostr = Str(seco)

'     ,  , 7  07
Yearstr = Format(yearstr , "00")
Monthstr = Format(monthstr , "00")
Datstr = Format(datstr , "00")
Hourstr = Format(hourstr , "00")
Minestr = Format(minestr , "00")
Secostr = Format(secostr , "00")


 Call D3310clear

   Call D3310position(4 , 0)                                '   X,Y
   Call D3310print( "DS1307")

   Call D3310position(3 , 2)
   Call D3310print(hourstr)

   Call D3310position(5 , 2)
   Call D3310print( ":")

   Call D3310position(6 , 2)
   Call D3310print(minestr)

   Call D3310position(8 , 2)
   Call D3310print( ":")

   Call D3310position(9 , 2)
   Call D3310print(secostr)



   Call D3310position(3 , 3)
   Call D3310print(datstr)

   Call D3310position(5 , 3)
   Call D3310print( "-")

   Call D3310position(6 , 3)
   Call D3310print(monthstr)

   Call D3310position(8 , 3)
   Call D3310print( "-")

   Call D3310position(9 , 3)
   Call D3310print(yearstr)

   Call D3310position(11 , 3)
   Call D3310print( "")


Return                                                      '





                       '    
'******************************************************************************
'******************************************************************************
Nastrojka:

Do                                                          '  

Select Case A
 Case 1 : Gosub Year
 Case 2 : Gosub Month
 Case 3 : Gosub Dat
 Case 4 : Gosub Hour
 Case 5 : Gosub Mine
 Case 6 : Gosub Seco
End Select

Waitms 400

Loop Until A = 0                                            '         


 Call D3310clear
 Call D3310position(2 , 2)
 Call D3310print( "")
 Waitms 200

Return



                       '   
'******************************************************************************
Year:                                                       '  
 Call D3310clear
 Call D3310position(0 , 0)
 Call D3310print( " ")

 Call D3310position(5 , 2)
 Call D3310print( "20")

 Call D3310position(7 , 2)
 Call D3310print(yearstr)

 Call D3310position(0 , 5)
 Call D3310print( "OK")

 Call D3310position(7 , 5)
 Call D3310print( "Down Up")


Return


Month:                                                      '  

 Call D3310clear
 Call D3310position(0 , 0)
 Call D3310print( " ")

 Call D3310position(6 , 2)
 Call D3310print(monthstr)

 Call D3310position(0 , 5)
 Call D3310print( "OK")

 Call D3310position(7 , 5)
 Call D3310print( "Down Up")


Return


Dat:                                                        '  

 Call D3310clear
 Call D3310position(0 , 0)
 Call D3310print( " ")

 Call D3310position(6 , 2)
 Call D3310print(datstr)

 Call D3310position(0 , 5)
 Call D3310print( "OK")

 Call D3310position(7 , 5)
 Call D3310print( "Down Up")

Return





Hour:                                                       '  

 Call D3310clear
 Call D3310position(0 , 0)
 Call D3310print( " ")

 Call D3310position(6 , 2)
 Call D3310print(hourstr)

 Call D3310position(0 , 5)
 Call D3310print( "OK")

 Call D3310position(7 , 5)
 Call D3310print( "Down Up")

Return





Mine:                                                       '  

 Call D3310clear
 Call D3310position(0 , 0)
 Call D3310print( " ")

 Call D3310position(6 , 2)
 Call D3310print(minestr)

 Call D3310position(0 , 5)
 Call D3310print( "OK")

 Call D3310position(7 , 5)
 Call D3310print( "Down Up")

Return






Seco:                                                       '  

 Call D3310clear
 Call D3310position(0 , 0)
 Call D3310print( "")

 Call D3310position(6 , 2)
 Call D3310print(secostr)

 Call D3310position(0 , 5)
 Call D3310print( "OK")

 Call D3310position(7 , 5)
 Call D3310print( "Down Up")

Return




'******************************************************************************
'******************************************************************************











                       '   S4
'******************************************************************************
Setup:
Incr A
Waitms 200
Gifr = 32

  If A = 7 Then                                             '   7     
    A = 0
    Gosub Otpravka
  End If

Return







                       '   S1
'******************************************************************************
Up:

If A > 0 Then

   Select Case A
    Case 1 : Incr Year                                      '  
    Case 2 : Incr Month                                     '  
    Case 3 : Incr Dat                                       '  
    Case 4 : Incr Hour                                      '  
    Case 5 : Incr Mine                                      '  
    Case 6 : Incr Seco                                      '  
   End Select



' ,    
Yearstr = Str(year)
Monthstr = Str(month)
Datstr = Str(dat)
Hourstr = Str(hour)
Minestr = Str(mine)
Secostr = Str(seco)

Yearstr = Format(yearstr , "00")
Monthstr = Format(monthstr , "00")
Datstr = Format(datstr , "00")
Hourstr = Format(hourstr , "00")
Minestr = Format(minestr , "00")
Secostr = Format(secostr , "00")

Waitms 5

Gifr = 64

End If

Return






                       '   S2
'******************************************************************************
Down:

If A > 0 Then

   Select Case A
    Case 1 : Decr Year                                      '  
    Case 2 : Decr Month                                     '  
    Case 3 : Decr Dat                                       '  
    Case 4 : Decr Hour                                      '  
    Case 5 : Decr Mine                                      '  
    Case 6 : Decr Seco                                      '  
   End Select


' 
Yearstr = Str(year)
Monthstr = Str(month)
Datstr = Str(dat)
Hourstr = Str(hour)
Minestr = Str(mine)
Secostr = Str(seco)

Yearstr = Format(yearstr , "00")
Monthstr = Format(monthstr , "00")
Datstr = Format(datstr , "00")
Hourstr = Format(hourstr , "00")
Minestr = Format(minestr , "00")
Secostr = Format(secostr , "00")

Waitms 5

Gifr = 128

End If

Return
